// menu.h


// Menu text
flash char MT_POWER[]                     = " ENTER >>>> ";
flash char MT_RADIKAL2[]                  = "* RaDiKaL2 *";
flash char MT_AUTOSEARCH[]                = "-AUTOSEARCH-";
flash char MT_AUTOSEARCH_SEARCH_UP[]      = " A.SEARCH >>";
flash char MT_MANUALSEARCH[]              = "- M.SEARCH -";
flash char MT_MANUALSEARCH_SEARCH[]       = "< M.SEARCH >";
flash char MT_MANUALSEARCH_SEARCH_UP[]    = " SEARCH UP  ";
flash char MT_MANUALSEARCH_SEARCH_DOWN[]  = " SEARCH DOWN";
flash char MT_OPTIONS[]                   = "- OPTIONS  -";
flash char MT_OPTIONS_ST_MN[]             = " Stereo/Mono";
flash char MT_STEREO[]                    = "   STEREO   ";
flash char MT_MONO[]                      = "    MONO    ";
flash char MT_OPTIONS_NOISE[]             = "NOISE ON/OFF";
flash char MT_NOISE_ON[]                  = "  NOISE ON  ";
flash char MT_NOISE_OFF[]                 = "  NOISE OFF ";


//  STATE                         INPUT       NEXT STATE 
flash struct
{
    unsigned char state;
    unsigned char input;
    unsigned char nextstate;
} menu_nextstate[]=    {
    {ST_POWER,                    KEY_ENTER,  ST_READ_MEM},   
    
    {ST_RADIKAL2,                 KEY_PLUS,   ST_OPTIONS},
    {ST_RADIKAL2,                 KEY_NEXT,   ST_MEM_UP},
    {ST_RADIKAL2,                 KEY_PREV,   ST_MEM_DOWN},
    {ST_RADIKAL2,                 KEY_MINUS,  ST_AUTOSEARCH},
    
    {ST_AUTOSEARCH,               KEY_PLUS,   ST_RADIKAL2},
    {ST_AUTOSEARCH,               KEY_ENTER,  ST_SCAN_UP},
    {ST_AUTOSEARCH,               KEY_PREV,   ST_RADIKAL2},
    {ST_AUTOSEARCH,               KEY_MINUS,  ST_MANUALSEARCH},
    
    {ST_MANUALSEARCH,             KEY_PLUS,   ST_AUTOSEARCH},
    {ST_MANUALSEARCH,             KEY_ENTER,  ST_MANUALSEARCH_SEARCH},
    {ST_MANUALSEARCH,             KEY_PREV,   ST_RADIKAL2},
    {ST_MANUALSEARCH,             KEY_MINUS,  ST_OPTIONS},
    
    {ST_MANUALSEARCH_SEARCH,      KEY_PLUS,   ST_MANUALSEARCH_SEARCH_UP},
    {ST_MANUALSEARCH_SEARCH,      KEY_PREV,   ST_MANUALSEARCH},
    {ST_MANUALSEARCH_SEARCH,      KEY_MINUS,  ST_MANUALSEARCH_SEARCH_DOWN},
    
    {ST_OPTIONS,                  KEY_PLUS,   ST_MANUALSEARCH}, 
    {ST_OPTIONS,                  KEY_NEXT,   ST_OPTIONS_ST_MN},
    {ST_OPTIONS,                  KEY_PREV,   ST_RADIKAL2},    
    {ST_OPTIONS,                  KEY_MINUS,  ST_RADIKAL2}, 

    {ST_OPTIONS_ST_MN,            KEY_PLUS,   ST_OPTIONS_NOISE},
    {ST_OPTIONS_ST_MN,            KEY_NEXT,   ST_STEREO_MONO},
    {ST_OPTIONS_ST_MN,            KEY_PREV,   ST_OPTIONS},
    {ST_OPTIONS_ST_MN,            KEY_MINUS,  ST_OPTIONS_NOISE},

    {ST_STEREO_MONO,              KEY_PLUS,   ST_STEREO},
    {ST_STEREO_MONO,              KEY_PREV,   ST_OPTIONS_ST_MN},
    {ST_STEREO_MONO,              KEY_MINUS,  ST_MONO},

    {ST_OPTIONS_NOISE,            KEY_PLUS,   ST_OPTIONS_ST_MN},
    {ST_OPTIONS_NOISE,            KEY_NEXT,   ST_NOISE},
    {ST_OPTIONS_NOISE,            KEY_PREV,   ST_OPTIONS},
    {ST_OPTIONS_NOISE,            KEY_MINUS,  ST_OPTIONS_ST_MN},
        
    {ST_NOISE,                    KEY_PLUS,   ST_NOISE_ON},
    {ST_NOISE,                    KEY_PREV,   ST_OPTIONS_NOISE},
    {ST_NOISE,                    KEY_MINUS,  ST_NOISE_OFF},
        
    {0,                           0,          0}};


flash struct
{
    unsigned char state;
    char flash *pText;
    char (*pFunc)(char input);
} menu_state[] = {
//  STATE                               STATE TEXT                   STATE_FUNC

    {ST_READ_MEM,                       NULL,                        Read_mem},
    {ST_RADIKAL2,                       MT_RADIKAL2,                 NULL},
    {ST_MEM_UP,                         NULL,                        Mem_up},
    {ST_MEM_DOWN,                       NULL,                        Mem_down},
    {ST_AUTOSEARCH,                     MT_AUTOSEARCH,               NULL},
    {ST_SCAN_UP,                        MT_AUTOSEARCH_SEARCH_UP,     Auto_scan_up},
    {ST_MANUALSEARCH,                   MT_MANUALSEARCH,             NULL},
    {ST_MANUALSEARCH_SEARCH,            MT_MANUALSEARCH_SEARCH,      NULL}, 
    {ST_MANUALSEARCH_SEARCH_UP,         MT_MANUALSEARCH_SEARCH_UP,   Manual_search_up},    
    {ST_MANUALSEARCH_SEARCH_DOWN,       MT_MANUALSEARCH_SEARCH_DOWN, Manual_search_down},
    {ST_OPTIONS,                        MT_OPTIONS,                  NULL},
    {ST_OPTIONS_ST_MN,                  MT_OPTIONS_ST_MN,            NULL},
    {ST_STEREO_MONO,                    MT_OPTIONS_ST_MN,            NULL},
    {ST_STEREO,                         MT_STEREO,                   Stereo},
    {ST_MONO,                           MT_MONO,                     Mono},
    {ST_OPTIONS_NOISE,                  MT_OPTIONS_NOISE,            NULL},
    {ST_NOISE,                          MT_OPTIONS_NOISE,            NULL},
    {ST_NOISE_ON,                       MT_NOISE_ON,                 Noise_on},
    {ST_NOISE_OFF,                      MT_NOISE_OFF,                Noise_off},

    {0,                                 NULL,                       NULL}};
