/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 3,6864 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <delay.h>
#include <stdio.h>
#include <3310.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm
#include <i2c.h>

#define TEA_ADR		0xC0            //  TEA  

//  /   TEA (. )
#define MUTE_ON     tea5768_w_data.wr_byte1 |= 0x80
#define MUTE_OFF    tea5768_w_data.wr_byte1 &= ~0x80
#define DTC75       tea5768_w_data.wr_byte5 |= 0x40 
#define DTC50       tea5768_w_data.wr_byte5 &= ~0x40
#define HCC_ON      tea5768_w_data.wr_byte4 |= 0x04 
#define HCC_OFF     tea5768_w_data.wr_byte4 &= ~0x04
#define SMUTE_ON      tea5768_w_data.wr_byte4 |= 0x08 
#define SMUTE_OFF     tea5768_w_data.wr_byte4 &= ~0x08

typedef unsigned char u8_t;
typedef unsigned int u16_t;
typedef unsigned long int u32_t;

struct tea5768wr_data
{
	u8_t wr_byte1;		//1-    
	u8_t wr_byte2;
	u8_t wr_byte3;		//3-    
	u8_t wr_byte4;
	u8_t wr_byte5;		//5-    
} tea5768_w_data;


struct tea5768rd_data
{
	u8_t rd_byte1;		//1-    
	u8_t rd_byte2;
	u8_t rd_byte3;		//3-    
	u8_t rd_byte4;
	u8_t rd_byte5;		//5-    
} tea5768_r_data;

//            TEA   :)
eeprom u8_t ee_b1 = 0x31;
eeprom u8_t ee_b2 = 0x20;
eeprom u8_t ee_b3 = 0x00;
eeprom u8_t ee_b4 = 0x1E;
eeprom u8_t ee_b5 = 0x00;
eeprom u16_t freq_ee = 1028;
eeprom u16_t mem[21];
eeprom u8_t mem_index_ee = 0;

float freq;                             // 
u8_t rx_pwr, if_cnt, exit_bit = 0;
u8_t mem_index = 1;
u32_t PLLfreq;
u16_t freq_lcd;
u8_t buf[3];

//   TEA 
void tea5768_write (struct tea5768wr_data *wdata)
{
    i2c_start();
    i2c_write(TEA_ADR);
    i2c_write(wdata->wr_byte1);
    i2c_write(wdata->wr_byte2);
    i2c_write(wdata->wr_byte3);
    i2c_write(wdata->wr_byte4);
    i2c_write(wdata->wr_byte5);
    i2c_stop();
}

//  TEA 
void tea5768_read (struct tea5768rd_data *rdata)
{
    i2c_start();
    i2c_write(TEA_ADR | 0x01);
    rdata->rd_byte1 = i2c_read(1);
    rdata->rd_byte2 = i2c_read(1);
    rdata->rd_byte3 = i2c_read(1);
    rdata->rd_byte4 = i2c_read(1);
    rdata->rd_byte5 = i2c_read(1);
    i2c_stop();
}

//  TEA  EEPROM     
void write_ee(void)
{
    ee_b1 = tea5768_w_data.wr_byte1;
    ee_b2 = tea5768_w_data.wr_byte2;
    ee_b3 = tea5768_w_data.wr_byte3;
    ee_b4 = tea5768_w_data.wr_byte4;
    ee_b5 = tea5768_w_data.wr_byte5; 
            
    freq_ee = freq / 100000;
    
    mem_index_ee = mem_index;
}

//       TEA 
//mute_bit - /   
void freq_up(char mute_bit)
{
    freq += 100000;
	if (freq == 108100000)
	{
	    freq = 87500000;
	}
	PLLfreq = 4 * (freq - 225000L) / 32768L;
	tea5768_w_data.wr_byte1 = ((PLLfreq >> 8) & 0x3F);
	tea5768_w_data.wr_byte2 = (PLLfreq & 0xFF);
    if(mute_bit) MUTE_ON;
    if(!mute_bit) MUTE_OFF;
	tea5768_write(&tea5768_w_data);
}

//       TEA 
//mute_bit - /   
void freq_down(char mute_bit)                        
{
    freq -= 100000;
	if (freq == 87400000)
	{
	    freq = 108000000;
	}
	PLLfreq = 4 * (freq - 225000L) / 32768L;
	tea5768_w_data.wr_byte1 = ((PLLfreq >> 8) & 0x3F);
	tea5768_w_data.wr_byte2 = (PLLfreq & 0xFF);
    if(mute_bit) MUTE_ON;
    if(!mute_bit) MUTE_OFF;
	tea5768_write(&tea5768_w_data);
}

//     
char rx_qual(void)                                   
{
    char x;
    
    tea5768_read(&tea5768_r_data);
    x = tea5768_r_data.rd_byte4 >> 4;
    
    if((x > 0)&&(x <= 3)) 
        {
            Nokia_cursorxy(0,0);
            Nokia_putstrf(")   ");
        }
    if((x >= 4)&&(x <= 7))
        {
            Nokia_cursorxy(0,0);
            Nokia_putstrf(")>  ");
        } 
    if((x >= 8)&&(x <= 11))
        {
            Nokia_cursorxy(0,0);
            Nokia_putstrf(")>> ");
        }   
    if((x >= 12)&&(x <= 15))
        {
            Nokia_cursorxy(0,0);
            Nokia_putstrf(")>>>");
        }
    return x;    
}

//    TEA
char if_count(void)                                       
{
    char y;
    
    tea5768_read(&tea5768_r_data);
    y = tea5768_r_data.rd_byte3 & 0x7F;
    delay_ms(10);
    return y;    
}

//    /
void st_mn(void)                                            
{
    tea5768_read(&tea5768_r_data);
    if((tea5768_r_data.rd_byte3 & 0x80) == 0x80) 
        {
            Nokia_cursorxy(72,0);
            Nokia_putstrf("ST");
        }
    else
        {
            Nokia_cursorxy(72,0);
            Nokia_putstrf("MN");
        }
}  

//   
void lcd(void)                                                 
{
    u8_t display_bit[4];
    
    freq_lcd = freq/10000;
    display_bit[0] = (freq_lcd / 10000)%10;
	if ( display_bit[0] == 0 ) display_bit[0] = 0x20;
	else display_bit[0] += 0x30;
	
	display_bit[1] = (freq_lcd / 1000)%10 + 0x30;
	display_bit[2] = (freq_lcd / 100)%10 + 0x30;
	display_bit[3] = (freq_lcd / 10)%10 + 0x30;
    /*Nokia_cursorxy(15,2);
	Nokia_putchar(display_bit[0]);
	Nokia_putchar(display_bit[1]);
	Nokia_putchar(display_bit[2]);
	Nokia_cursorxy(33,2);
    Nokia_putchar('.');
	Nokia_putchar(display_bit[3]);
    Nokia_cursorxy(45,2);
	Nokia_putstrf(" MHz");*/
    //char_start = 10;
    Nokia_putnum_megafont(display_bit[0], 10);
    Nokia_putnum_megafont(display_bit[1], 22);
    Nokia_putnum_megafont(display_bit[2], 34);
    Nokia_putnum_megafont('.', 46);
    Nokia_putnum_megafont(display_bit[3], 51);
} 


void main(void)
{
u8_t i = 0;

DDRB=0xFF; //DDRx   0xFF  3310

ACSR=0x80;

i2c_init();

Nokia_initlcd();

tea5768_w_data.wr_byte1 = ee_b1;               //  TEA  EEPROM
tea5768_w_data.wr_byte2 = ee_b2;
tea5768_w_data.wr_byte3 = ee_b3;
tea5768_w_data.wr_byte4 = ee_b4;
tea5768_w_data.wr_byte5 = ee_b5;

MUTE_ON;                                       //     
tea5768_write(&tea5768_w_data);
delay_ms(1000);
MUTE_OFF;
tea5768_write(&tea5768_w_data);

freq = freq_ee * 100000;
lcd();

while (1)
      {
      if(PIND.0 == 0)
        {
            delay_ms(3000);
            if(PIND.0 == 0)                                     // 
                {   
                    Nokia_cursorxy(0,5);
                    Nokia_putstrf_inverse("-AUTOSEARCH-");
                    freq = 87400000;
                    while(i < 21)
                    {                        
                        i++;
                        while (exit_bit == 0)
                        {
                            freq_up(1);
                            delay_ms(58);                 //!!!  -      
                            if((if_count() > 0x36) && (if_count() < 0x3F) && (rx_qual() > 8)) exit_bit = 1;
                            lcd();
                        }
                        freq_ee = freq / 100000;
                        mem[i] = freq_ee;
                        sprintf(buf, "%02u", i);
                        Nokia_cursorxy(36,0);
                        Nokia_putstr(buf);
                        exit_bit = 0;
                    }                
                i = 0;
                MUTE_OFF;
                tea5768_write(&tea5768_w_data);
                write_ee();
                delay_ms(100);
                }    
        } 
        
      if(PIND.1 == 0)                                        //     
        {      
	        mem_index += 1;
            if (mem_index == 21)
	            {
	                mem_index = 1;
	            }
            freq = mem[mem_index] * 100000;
	        PLLfreq = 4 * (freq - 225000L) / 32768L;
	        tea5768_w_data.wr_byte1 = ((PLLfreq >> 8) & 0x3F);
	        tea5768_w_data.wr_byte2 = (PLLfreq & 0xFF);
	        tea5768_write(&tea5768_w_data);
            sprintf(buf, "%02u", mem_index);
            lcd();
            Nokia_cursorxy(36,0);
            Nokia_putstr(buf);
            write_ee();
            delay_ms(150);
        }
      if(PIND.2 == 0)                                         //     
        {
            mem_index -= 1;
	        if (mem_index == 0)
	            {
	                mem_index = 20;
	            }
            freq = mem[mem_index] * 100000;
	        PLLfreq = 4 * (freq - 225000L) / 32768L;
	        tea5768_w_data.wr_byte1 = ((PLLfreq >> 8) & 0x3F);
	        tea5768_w_data.wr_byte2 = (PLLfreq & 0xFF);
	        tea5768_write(&tea5768_w_data);
            sprintf(buf, "%02u", mem_index);            
            lcd();
            Nokia_cursorxy(36,0);
            Nokia_putstr(buf);
            write_ee();
            delay_ms(150);
        }
        
      if(PIND.3 == 0)                                        //   
        {
        while(exit_bit == 0)
            {          
                delay_ms(10);
                freq_up(1);
                write_ee();
                rx_pwr = rx_qual();
                if_cnt = if_count();
                if((if_count() > 0x36) && (if_count() < 0x3F) && (rx_qual() > 8)) exit_bit = 1;
                lcd(); 
            }
        exit_bit = 0;
        MUTE_OFF;
        tea5768_write(&tea5768_w_data);
        write_ee();
        delay_ms(100);
        } 
      
      if(PIND.4 == 0)                                        //   
        {
        while(exit_bit == 0)
            {          
                delay_ms(1);
                freq_down(1);
                write_ee();
                rx_pwr = rx_qual();
                if_cnt = if_count();
                if((if_count() > 0x36) && (if_count() < 0x3F) && (rx_qual() > 7)) exit_bit = 1;
                lcd(); 
            }
        exit_bit = 0;
        MUTE_OFF;
        tea5768_write(&tea5768_w_data);
        write_ee();
        delay_ms(100);
        }
      
      Nokia_cursorxy(0,5);                                   //
      Nokia_putstrf_inverse("* RaDiKaL2 *");
      
      rx_qual();
      if_count();
      st_mn(); 
      };
}
